{% extends 'base.html' %}
{% load static %}
{% block meta_tags %}<title>Predict Human Face, Age and Gender - Components</title>
        <meta name="description" content="Detect Human face, age and gender from image using opencv module.">{% endblock %}
{% block content %}
    <style>
        .loader
        {
              position: fixed;
              overflow: hidden;
              z-index: 5000;
              top: 0;
              left: 0;
              text-align: center;
              background: #ffffff8c;
              color: #fff;
                margin-left: auto;
                margin-right: auto;
                display: block;
        }
        .loader {
            display:none;   
        }
    </style>
    <div class="subcontainer">
        <div class="row">
            <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                <h3 class="text-center pb-2"><u>Predict Human Face, Age & Gender</u></h3>
            </div>
          <div class="col-md-5 col-sm-12 col-xs-12 col-lg-3 pb-3">
            <h5>Sample output images</h5>
            <img src="{% static 'image_process/images/examples/example_1.png' %}" width="300" height="250"class="img-responsive"/>
            <img src="{% static 'image_processimages/examples/example_2.png' %}" width="300" height="250" class="img-responsive pt-3"/>
          </div>      
          <div class="col-md-7 col-sm-12 col-xs-12 col-lg-8">
            <p>The purpose of this component is find the human <strong>face</strong> from uploaded photo and get <strong>AGE</strong> and <strong>Gender</strong> of the found faces. We have used <strong>Opencv</strong> module to achive this also we have used <strong>Deep learning</strong>.</p>
            <form class="upload=photo" method="POST" id="upload_photo" enctype="multipart/form-data">
                <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                    <div class="row">
                        <div class="form-group">
				            <label for="id_image">Please upload photo</label>
                            <input type="file" name="{{form.image.html_name}}" accept="image/*" class="form-control-file" required="" id="{{form.image.id_for_label}}">
                            {{ form.image.errors }}
                            {% csrf_token %}
                        </div>
                    </div>
                </div>
                <div>
                    <ul>
                        <li>We are not storing your uploded image anywhere in our server.</li>
                        <li>Plese give your feedback to improve this component <a>Feedback.</a></li>
                    </ul>
                </div>
                <div class="col-md-12 col-sm-12 col-xs-12 col-lg-12">
                    <div class="row">
                        <div class="form-group">
                            <button type="submit" class="btn btn-success">Upload</button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="loader">
                            <img src="{% static 'image_process/loading.gif' %}" class="img-responsive"/>
                        </div>
                    </div>
                </div>
            </form>
            <div class="col-md-12 col-sm-6 col-xs-6 col-lg-12">
                <div class="row">
                    <div class="output_image"></div>
                </div>
            </div>
          </div>
        </div>
    </div>
    <script type="text/javascript">
        $(document).ajaxStart(function(){
            $(".loader").show()    
        });
        $(document).on('submit', '#upload_photo',function(e){
            e.preventDefault();
	    $(".output_image").html("")
            var formData = new FormData($(this).get(0))
            $.ajax({
                type:'POST',
                url:'{% url "image_process:predict_face" %}',
                data:formData,
                cache: false,
                processData: false,
                contentType: false,
                success:function(response){
                    if (response.error) {
                        var error = "<ul class='errorlist'>";
                        $.each(response.error, function(key, value){
                            error += "<li>"+value+"</li>"
                        })
                        error +="</ul>";
                        $(".output_image").html(error)
                    } 
                    else{
                        //img = '<img src="'+ response.image_url+'">'
                        //var image = new Image(100, 2000);
                        //image.src = 'data:image/png;base64,'+ response.image_url
                        //image.class = "img-responsive"
                        //document.body.appendChild(image);
                        image_src = 'data:image/png;base64,'+ response.image_url
                        img = '<div>Output:<img src="'+ image_src+'" class="img-responsive_"></div>'
                        $(".output_image").html(img)
                    }
                },
                error : function(xhr,errmsg,err) {
                console.log("Error"); // provide a bit more info about the error to the console
            }
            });
        });
        $(document).ajaxStop(function(){
            $(".loader").hide()    
        });
    </script>
{% endblock %}
